--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- emPartyInvite
-- パーティー編成補助
-- Version 0.02
-- written by エミファ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

local emPartyInvite = {};
_G.emPartyInvite = emPartyInvite;

-- 文字列
local EMPI_LOADEDTEXT = "emPartyInvite ver 0.02 loaded.";
local EMPI_MEMBERS = "emPartyInvite Members :";
local EMPI_REG = "emPartyInvite regist members.";
--local EMPI_INVITE = "Invite to %s";
local EMPI_MAXPARTY = 5;	-- 最大人数(自分をのぞいて5人)

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベント登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:OnLoad(this)
	emPartyInvite_Frame:RegisterEvent( "VARIABLES_LOADED" );
	SaveVariables( "EMPI_PROFILES" );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベントハンドラ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:OnEvent( event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 )
	self[event]( self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ロード時
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:VARIABLES_LOADED()
	DEFAULT_CHAT_FRAME:AddMessage( EMPI_LOADEDTEXT );
	if (not EMPI_PROFILES) then
		EMPI_PROFILES = {};
		for i = 1,  EMPI_MAXPARTY do
			EMPI_PROFILES[i] = "";
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:View()
	DEFAULT_CHAT_FRAME:AddMessage(EMPI_MEMBERS, 1, 1, 1);
	local i, memName;
	for i = 1,  EMPI_MAXPARTY do
		if ( ( EMPI_PROFILES[i] == "" ) or (EMPI_PROFILES[i] == nil) ) then
			break;
		else
			if ( InPartyByName ( EMPI_PROFILES[i] ) ) then
				DEFAULT_CHAT_FRAME:AddMessage( EMPI_PROFILES[i], 0.82, 0.80, 0.21 );
			else
				DEFAULT_CHAT_FRAME:AddMessage( EMPI_PROFILES[i], 0.6, 0.6, 0.6 );
			end
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--　登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:RegistMember()
	local i;
	for i = 1,  EMPI_MAXPARTY do
		EMPI_PROFILES[i] = GetPartyMember( i );
	end
	emPartyInvite:View();
	DEFAULT_CHAT_FRAME:AddMessage(EMPI_REG, 1, 1, 1);
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--　誘う
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:Invite()
	local i, inviteName;
	for i = 1,  EMPI_MAXPARTY do
		if ( ( EMPI_PROFILES[i] == "" ) or (EMPI_PROFILES[i] == nil) ) then
			break;
		else
			if ( InPartyByName ( EMPI_PROFILES[i] ) == false ) then
				-- PTにいないので誘う
				InviteByName( EMPI_PROFILES[i] );
			end
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
--　蹴る
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emPartyInvite:Kick()
	local i, inviteName;
	for i = 1,  EMPI_MAXPARTY do
		if ( ( EMPI_PROFILES[i] == "" ) or (EMPI_PROFILES[i] == nil) ) then
			break;
		else
			if ( InPartyByName ( EMPI_PROFILES[i] ) ) then
				-- PTにいるので蹴る
				UninviteByName( EMPI_PROFILES[i] );
			end
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- スラッシュコマンド
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
SLASH_emPartyInvite1 = "/emPartyInvite";
SLASH_emPartyInvite2 = "/empi";
SlashCmdList["emPartyInvite"] = function(editBox, msg)
	msg = string.lower(msg)
	if (msg == "reg") then
		-- 登録
		emPartyInvite:RegistMember();
	elseif (msg == "inv") then
		-- 誘う
		emPartyInvite:Invite();
	elseif (msg == "kick") then
		-- 誘う
		emPartyInvite:Kick();
	else
		-- 表示
		emPartyInvite:View();
	end
end
